
### LMB big experiment

setwd("N://Alfonso_Gomez//1 - Experimental Procedures//191018_AdV5-dV_&_VKR_LMB_delivery//CellProfAnalys")

Nuclear_virus <- read.csv2("191022_dV_VKR_EdC_LMB_delivery_Maskedvirus.csv", header = T, sep = ",")

Masked_genome <- read.csv2("191022_dV_VKR_EdC_LMB_delivery_MaskGenome.csv", header = T, sep = ",")


##Set your treatments and your times

library("stringr")

add_my_numbers1 <- function(data){
  a <- str_split_fixed(data$Metadata_sample,"_",n = 7)
  V <- a[,5]
  Trt <- a[,6]
  Tim <- as.numeric(a[,7])
  data <- cbind(data,"Virus" =V, "Drug"= Trt, "Time"= Tim)
  return(data)
}

Con_time <- add_my_numbers1(Nuclear_virus)
Con_time_gen <- add_my_numbers1(Masked_genome)

## Convert those treatments into numbers so the analysis will be easier

Con_time$Virus <- gsub("Mock","0", Con_time$Virus)
Con_time$Virus <- gsub("wt","1", Con_time$Virus)
Con_time$Virus <- gsub("VKR","2", Con_time$Virus)
Con_time$Virus <- gsub("dV","3", Con_time$Virus)
Con_time$Virus <- as.numeric(Con_time$Virus)

Con_time$Drug <- gsub("Mock","0", Con_time$Drug)
Con_time$Drug <- gsub("LMB","1", Con_time$Drug)
Con_time$Drug <- as.numeric(Con_time$Drug)

Con_time$Time <- gsub("480","4", Con_time$Time)
Con_time$Time <- gsub("300","3", Con_time$Time)
Con_time$Time <- gsub("180","2", Con_time$Time)
Con_time$Time <- gsub("90","1", Con_time$Time)
Con_time$Time <- gsub("30","0", Con_time$Time)
Con_time$Time <- as.numeric(Con_time$Time)



Con_time_gen$Virus <- gsub("Mock","0", Con_time_gen$Virus)
Con_time_gen$Virus <- gsub("wt","1", Con_time_gen$Virus)
Con_time_gen$Virus <- gsub("VKR","2", Con_time_gen$Virus)
Con_time_gen$Virus <- gsub("dV","3", Con_time_gen$Virus)
Con_time_gen$Virus <- as.numeric(Con_time_gen$Virus)

Con_time_gen$Drug <- gsub("Mock","0", Con_time_gen$Drug)
Con_time_gen$Drug <- gsub("LMB","1", Con_time_gen$Drug)
Con_time_gen$Drug <- as.numeric(Con_time_gen$Drug)

Con_time_gen$Time <- gsub("480","4", Con_time_gen$Time)
Con_time_gen$Time <- gsub("300","3", Con_time_gen$Time)
Con_time_gen$Time <- gsub("180","2", Con_time_gen$Time)
Con_time_gen$Time <- gsub("90","1", Con_time_gen$Time)
Con_time_gen$Time <- gsub("30","0", Con_time_gen$Time)
Con_time_gen$Time <- as.numeric(Con_time_gen$Time)

######
## Now its time to count the viruses (Pos, Neg,...)
######
## First transform the columns of the signals into numbers (not characters)

as.numeric.factor <- function(x){
  as.numeric(levels(x))[x]
}

Con_time$Intensity_MeanIntensity_Hex <- as.numeric.factor(Con_time$Intensity_MeanIntensity_Hex)
Con_time$Intensity_MeanIntensity_EdC <- as.numeric.factor(Con_time$Intensity_MeanIntensity_EdC)


Con_time_gen$Intensity_MeanIntensity_Hex <- as.numeric.factor(Con_time_gen$Intensity_MeanIntensity_Hex)
Con_time_gen$Intensity_MeanIntensity_EdC <- as.numeric.factor(Con_time_gen$Intensity_MeanIntensity_EdC)

##Make a plot to help you choose your threshold

library("ggplot2")

library("reshape2")

library("Hmisc")

ggplot(data = Con_time,aes(x = Metadata_sample,y = Metadata_Site))+
  geom_point()


ggplot(data = Con_time,aes(x = Metadata_sample,y = Intensity_MeanIntensity_EdC))+
  geom_boxplot(color = "black") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("pVI intensity per object") +
  xlab("Well") +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))


ggplot(data = Con_time_gen,aes(x = Metadata_sample,y = Intensity_MeanIntensity_Hex))+
  geom_boxplot(color = "black") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("pVI intensity per object") +
  xlab("Well") +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

## Time for the experiment
#Count the amount of virus particles per cell as well as the amount of positive pVI VP

back_cap <- subset(Con_time, Con_time$Virus == 0)
back_cap <- subset(Con_time, Con_time$Virus == 1 & Con_time$Drug == 0 & Con_time$Time == 2)

back_cap_back <- back_cap[which(back_cap$Intensity_MeanIntensity_EdC >= 0.04),]

back_gen <- subset(Con_time_gen, Con_time_gen$Virus == 0)
back_gen <- subset(Con_time_gen, Con_time_gen$Virus == 1 & Con_time_gen$Drug == 0 & Con_time_gen$Time == 2)

back_gen_back <- back_gen[which(back_gen$Intensity_MeanIntensity_Hex >= 0.02),]

#####
##### Export all the raw intensities in an ordered manner
#####

genome <- as.data.frame(cbind('EdC' = Con_time_gen$Intensity_MeanIntensity_EdC, '9C12'=Con_time_gen$Intensity_MeanIntensity_Hex, 
                              'Nucleus'=Con_time_gen$Parent_Nuclus,'Drug' =Con_time_gen$Drug,
                              'Virus'=Con_time_gen$Virus, 'Time'=Con_time_gen$Time))

Virus <- as.data.frame(cbind( '9C12'=Con_time$Intensity_MeanIntensity_Hex, 'EdC' = Con_time$Intensity_MeanIntensity_EdC, 
                              'Nucleus'=Con_time$Parent_Nuclus,'Drug' =Con_time$Drug,
                              'Virus'=Con_time$Virus, 'Time'=Con_time$Time))

make_my_table <- function(exp) {
  for (Vi in 1:3){
    for (Ti in 0:4){
      for (tr in 0:1){
        clust <- subset(exp, (exp$Drug == tr) & (exp$Virus == Vi) & (exp$Time == Ti))
        output <- rbind(output, clust)
      }
    }
  }
  return(output)
}

output <- matrix(nrow = 0, ncol = 6)

genome2 <- make_my_table(genome)
write.csv2(genome2, file = "genome2.csv")

Virus2 <- make_my_table(Virus)
write.csv2(Virus2, file = "Virus2.csv")

Cyt_genome <- subset(genome, genome$Nucleus == 0)
Nuc_genome <- subset(genome, genome$Nucleus != 0)

### Do the equations

output2 <- matrix(nrow = 0, ncol = 11)

cell_counting <- function(exp){
  for (v in 1:3){
    for (i in 0:4){
      for (fr in 0:1){
        g <- subset(exp, (exp$Virus == v) & (exp$Drug == fr) & (exp$Time == i))
        msite <- max(g$Metadata_Site, na.rm = T)
        for (k in 0:11){
          p <- subset(g,(g$Metadata_Site == k))
          ncel <- max(p$Parent_Cell, na.rm = T)
          if (ncel == -Inf){
            output2 <- output2
          } else {
            for (c in 1:ncel){
              cells <- length(p[p[,"Parent_Cell"] == c,][,1])
              nucleus <- length(p[p[,"Parent_Nuclus"] == c,][,1])
              genomes <- dim(p[(p$Intensity_MeanIntensity_EdC < 0.04) & (p$Parent_Cell == c),])[1]
              percent <- (nucleus/cells)*100
              percentFree <- (genomes/cells)*100
              code <- v * 100 + i * 10 + fr
              output2 <- rbind(output2,c(v, fr, i, code, k, c, cells, nucleus,genomes,percent,percentFree))
            }
          }
        }
      }
    }
  }
  return(output2)
}

EndEsc_cellcount <- cell_counting(Con_time)
colnames(EndEsc_cellcount) <- c("Virus", "Drug", "Time","Code","Site", "Cell", "Virus_particles","Virus_in_nucleus","VirusFree","Percent","PercentFree")

EndEsc_cellcount <- as.data.frame(EndEsc_cellcount)

EndEsc_cellcount$Code <- gsub("300","dV_Mock_30min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("320","dV_Mock_180min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("301","dV_LMB_30min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("311","dV_LMB_90min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("321","dV_LMB_180min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("331","dV_LMB_300min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("341","dV_LMB_480min", EndEsc_cellcount$Code)

EndEsc_cellcount$Code <- gsub("100","wt_Mock_30min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("120","wt_Mock_180min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("101","wt_LMB_30min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("111","wt_LMB_90min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("121","wt_LMB_180min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("131","wt_LMB_300min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("141","wt_LMB_480min", EndEsc_cellcount$Code)

EndEsc_cellcount$Code <- gsub("200","VKR_Mock_30min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("220","VKR_Mock_180min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("201","VKR_LMB_30min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("211","VKR_LMB_90min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("221","VKR_LMB_180min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("231","VKR_LMB_300min", EndEsc_cellcount$Code)
EndEsc_cellcount$Code <- gsub("241","VKR_LMB_480min", EndEsc_cellcount$Code)

EndEsc_cellcount$Code <- gsub("3","Mock_Mock_20min", EndEsc_cellcount$Code)

write.csv2(EndEsc_cellcount, file = "191026_EdC_LMB_delivery_virus_count.csv")

EndEsc_cellcount$Virus <- gsub("0","Mock", EndEsc_cellcount$Virus)
EndEsc_cellcount$Virus <- gsub("1","dV", EndEsc_cellcount$Virus)
EndEsc_cellcount$Virus <- gsub("2","VKR", EndEsc_cellcount$Virus)
EndEsc_cellcount$Virus <- gsub("3","wt", EndEsc_cellcount$Virus)

EndEsc_cellcount$Drug <- gsub("0","Mock", EndEsc_cellcount$Drug)
EndEsc_cellcount$Drug <- gsub("1","LMB", EndEsc_cellcount$Drug)

EndEsc_cellcount$Time <- gsub("0","40", EndEsc_cellcount$Time)
EndEsc_cellcount$Time <- gsub("1","60", EndEsc_cellcount$Time)
EndEsc_cellcount$Time <- gsub("2","180", EndEsc_cellcount$Time)
EndEsc_cellcount$Time <- gsub("3","300", EndEsc_cellcount$Time)
EndEsc_cellcount$Time <- gsub("40","20", EndEsc_cellcount$Time)


### Genome counting -----------------

output2 <- matrix(nrow = 0, ncol = 12)

genome_counting <- function(exp){
  for (v in 1:3) {
    for (i in 0:4) {
      for (fr in 0:1){
        Tim <- subset(exp,(exp$Virus == v) & (exp$Drug == fr) & (exp$Time == i))
        for (sit in 0:11) {
          ce <- subset(Tim, (Tim$Metadata_Site == sit))
          ncel <- max(ce$Parent_Cell, na.rm = T)
          if (ncel == -Inf) {
            output2 <- output2
          } else {
            for (c in 1:ncel) {
              Genomes <- length(ce[ce[,"Parent_Cell"] == c,][,1])
              FreeNomes <- dim(ce[(ce$Intensity_MeanIntensity_Hex < 0.02) & (ce$Parent_Cell == c),])[1]
              Nucleus <- length(ce[ce[,"Parent_Nuclus"] == c,][,1])
              FreeNucleus <- dim(ce[(ce$Intensity_MeanIntensity_Hex < 0.02) & (ce$Parent_Nuclus == c),])[1]
              code <- v * 100 + i * 10 + fr
              if (Genomes == 0){
                PercentFree <- 0
                PercentFreeNuc <- 0
                PercentFreeCyt <- 0
              } else {
                PercentFree <- (FreeNomes/Genomes)*100
                PercentFreeNuc <- (FreeNucleus/FreeNomes)*100
                PercentFreeCyt <- ((FreeNomes-FreeNucleus)/FreeNomes)*100
              }
              output2 <- rbind(output2,c(v, fr, i, code, c, Genomes,FreeNomes, Nucleus,FreeNucleus,PercentFree, PercentFreeNuc,PercentFreeCyt))
            }
          }
        }
      }
    }
  }
  return(output2)
}

EndEsc_gencount <- genome_counting(Con_time_gen)
colnames(EndEsc_gencount) <- c("Virus","Drug","Time","Code","Cell", "Genomes", 
                               "Free_Genomes","Nuc_Gen","Free_Nuc_Gen","Percent_Free","Percent_Free_Nuc", "Percent_Free_cyt")

EndEsc_gencount <- as.data.frame(EndEsc_gencount)

EndEsc_gencount$Code <- gsub("300","dV_Mock_30min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("320","dV_Mock_180min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("301","dV_LMB_30min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("311","dV_LMB_90min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("321","dV_LMB_180min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("331","dV_LMB_300min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("341","dV_LMB_480min", EndEsc_gencount$Code)

EndEsc_gencount$Code <- gsub("100","wt_Mock_30min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("120","wt_Mock_180min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("101","wt_LMB_30min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("111","wt_LMB_90min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("121","wt_LMB_180min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("131","wt_LMB_300min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("141","wt_LMB_480min", EndEsc_gencount$Code)

EndEsc_gencount$Code <- gsub("200","VKR_Mock_30min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("220","VKR_Mock_180min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("201","VKR_LMB_30min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("211","VKR_LMB_90min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("221","VKR_LMB_180min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("231","VKR_LMB_300min", EndEsc_gencount$Code)
EndEsc_gencount$Code <- gsub("241","VKR_LMB_480min", EndEsc_gencount$Code)

write.csv2(EndEsc_gencount, file = "191026_EdC_LMB_delivery_genome_count.csv")

EndEsc_gencount <- read.csv2("190726_EdC_LMB_delivery_genome_count.csv", header = T)

### Plotting --------------

ggplot(data = EndEsc_cellcount,aes(x = Code,y = Virus_particles))+
  geom_boxplot(color = "black") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("Virus particles per cell") +
  xlab("Well") +
  ylim(0, 130) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

VP_Ntrt <- subset(EndEsc_cellcount, EndEsc_cellcount$Drug == 0)

ggplot(data = VP_Ntrt,aes(x = Code,y = Virus_in_nucleus))+
  geom_boxplot(color = "black") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("Virus particles per cell") +
  xlab("Well") +
  ylim(0, 100) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))


ggplot(data = EndEsc_cellcount,aes(x = Time,y = PercentFree))+
  geom_boxplot(color = "black") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("pVI intensity per object") +
  xlab("Well") +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

library(RColorBrewer)

wt_Ntrt <- subset(EndEsc_gencount, EndEsc_gencount$Virus == 1 & EndEsc_gencount$Drug == 0)
wt_LMB <- subset(EndEsc_gencount, EndEsc_gencount$Virus == 1 & EndEsc_gencount$Drug == 1)

dV_Ntrt <- subset(EndEsc_gencount, EndEsc_gencount$Virus == 3 & EndEsc_gencount$Drug == 0)
dV_LMB <- subset(EndEsc_gencount, EndEsc_gencount$Virus == 3 & EndEsc_gencount$Drug == 1)

ggplot()+
  geom_jitter(data = wt_Ntrt, aes(x = Code, y = Percent_Free, colour = Percent_Free_cyt), binaxis='y', stackdir='center',
               stackratio=0.01, dotsize=0.3, alpha=0.8, position = position_jitter(width = 0.2))+
  geom_jitter(data = dV_Ntrt, aes(x = Code, y = Percent_Free, colour = Percent_Free_cyt), binaxis='y', stackdir='center',
               stackratio=0.01, dotsize=0.3, alpha=0.8, position = position_jitter(width = 0.2))+
  scale_colour_gradient2(midpoint= 50, low="green", mid="yellow", high="red") +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1, colour = 'black'), axis.ticks = element_line(colour = 'black'))+
  theme(axis.text.y = element_text(colour = 'black'))

## scale_colour_gradient(low = "green", high = "red")
## scale_colour_brewer(palette = "RdYlGn")

ggplot(data = EndEsc_cellcount,aes(x = Code, y = PercentFree))+
  geom_dotplot(binaxis='y', stackdir='center',
               stackratio=0.01, dotsize=0.3, alpha=0.5, position = position_jitter(width = 0.2)) +
  geom_boxplot(color = "black", outlier.colour = NA) +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("EdC intensity in VP") +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1, colour = 'black'), axis.ticks = element_line(colour = 'black'))+
  theme(axis.text.y = element_text(colour = 'black'))

ggplot(data = EndEsc_gencount,aes(x = Code, y = Percent_Free))+
  geom_dotplot(binaxis='y', stackdir='center',
               stackratio=0.01, dotsize=0.3, alpha=0.5, position = position_jitter(width = 0.2)) +
  geom_boxplot(color = "black", outlier.colour = NA) +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("EdC intensity in VP") +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1, colour = 'black'), axis.ticks = element_line(colour = 'black'))+
  theme(axis.text.y = element_text(colour = 'black'))

# Calculate the means ----------------------------------------------------

calc_my_meansd <- function(titr){
  output <- matrix(nrow = 0,ncol = 6)
  for (v in 1:3){
    for (fr in 0:1){
      for (i in 0:4){
        g <- subset(titr, (titr$Virus == v) & (titr$Drug == fr) & (titr$Time == i))
        inf <- mean(g$Virus_particles)
        sd <- sd(g$Virus_particles)
        code <- v * 100 + i * 10 + fr
        output <- rbind(output,c(v, fr, i,code,inf, sd))
      }
    }
  }
  return(output)
}

Mean_and_SD <- calc_my_meansd(EndEsc_cellcount)
colnames(Mean_and_SD) <- c("Virus",  "Drug", "Time","Code", "MeanVP", "SD")

Mean_and_SD <- as.data.frame(Mean_and_SD)

Mean_and_SD$Code <- gsub("300","dV_Mock_30min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("320","dV_Mock_180min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("301","dV_LMB_30min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("311","dV_LMB_90min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("321","dV_LMB_180min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("331","dV_LMB_300min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("341","dV_LMB_480min", Mean_and_SD$Code)

Mean_and_SD$Code <- gsub("100","wt_Mock_30min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("120","wt_Mock_180min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("101","wt_LMB_30min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("111","wt_LMB_90min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("121","wt_LMB_180min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("131","wt_LMB_300min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("141","wt_LMB_480min", Mean_and_SD$Code)

Mean_and_SD$Code <- gsub("200","VKR_Mock_30min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("220","VKR_Mock_180min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("201","VKR_LMB_30min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("211","VKR_LMB_90min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("221","VKR_LMB_180min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("231","VKR_LMB_300min", Mean_and_SD$Code)
Mean_and_SD$Code <- gsub("241","VKR_LMB_480min", Mean_and_SD$Code)

write.csv2(Mean_and_SD, file = "191026_EdC_LMB_delivery_virus_mean.csv")

Mean_and_SD$Virus <- gsub("0","Mock", Mean_and_SD$Virus)
Mean_and_SD$Virus <- gsub("1","dV", Mean_and_SD$Virus)
Mean_and_SD$Virus <- gsub("2","VKR", Mean_and_SD$Virus)
Mean_and_SD$Virus <- gsub("3","wt", Mean_and_SD$Virus)
Mean_and_SD$Drug <- gsub("0","Mock", Mean_and_SD$Drug)
Mean_and_SD$Drug <- gsub("1","LMB", Mean_and_SD$Drug)
Mean_and_SD$Time <- gsub("0","20", Mean_and_SD$Time)
Mean_and_SD$Time <- gsub("1","120", Mean_and_SD$Time)

### Calculate the mean of missdelivery EdC -----------------

calc_my_meansd_gen <- function(titr){
  output <- matrix(nrow = 0,ncol = 12)
  for (v in 1:3){
    for (fr in 0:1){
      for (i in 0:4){
        g <- subset(titr, (titr$Virus == v) & (titr$Drug == fr) & (titr$Time == i))
        inf <- mean(g$Genomes)
        sd <- sd(g$Genomes)
        free <- mean(g$Percent_Free)
        freesd <- sd(g$Percent_Free)
        cytmean <- mean(g$Percent_Free_cyt)
        cytsd <- sd(g$Percent_Free_cyt)
        nucmean <- mean(g$Percent_Free_Nuc)
        nucsd <- sd(g$Percent_Free_Nuc)
        code <- v * 100 + i * 10 + fr
        output <- rbind(output,c(v, fr, i,code, inf, sd, free, freesd, cytmean, cytsd, nucmean, nucsd))
      }
    }
  }
  return(output)
}


Mean_and_SD_gen <- calc_my_meansd_gen(EndEsc_gencount)
colnames(Mean_and_SD_gen) <- c("Virus",  "Drug", "Time", "Code", "MeanGen", "SDGen", "Percent_Free_mean", "Percent_Free_SD",
                               "Percent_Free_cyt_mean", "Percent_Free_cyt_SD","Percent_Free_Nuc_mean","Percent_Free_Nuc_SD")
Mean_and_SD_gen <- as.data.frame(Mean_and_SD_gen)

Mean_and_SD_gen$Code <- gsub("300","dV_Mock_30min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("320","dV_Mock_180min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("301","dV_LMB_30min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("311","dV_LMB_90min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("321","dV_LMB_180min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("331","dV_LMB_300min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("341","dV_LMB_480min", Mean_and_SD_gen$Code)

Mean_and_SD_gen$Code <- gsub("100","wt_Mock_30min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("120","wt_Mock_180min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("101","wt_LMB_30min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("111","wt_LMB_90min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("121","wt_LMB_180min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("131","wt_LMB_300min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("141","wt_LMB_480min", Mean_and_SD_gen$Code)

Mean_and_SD_gen$Code <- gsub("200","VKR_Mock_30min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("220","VKR_Mock_180min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("201","VKR_LMB_30min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("211","VKR_LMB_90min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("221","VKR_LMB_180min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("231","VKR_LMB_300min", Mean_and_SD_gen$Code)
Mean_and_SD_gen$Code <- gsub("241","VKR_LMB_480min", Mean_and_SD_gen$Code)

write.csv2(Mean_and_SD_gen, file = "191026_EdC_LMB_delivery_genomes_mean.csv")


##########################
######## Graphs so cool that you wont even believe them -------------------------------------------------------------------
##########################

Threshold <- 0.04

setwd("N://Alfonso_Gomez//1 - Experimental Procedures//191018_AdV5-dV_&_VKR_LMB_delivery//CellProfAnalys")

Nuclear_virus <- read.csv2("191022_dV_VKR_EdC_LMB_delivery_Maskedvirus.csv", header = T, sep = ",")

Masked_genome <- read.csv2("191022_dV_VKR_EdC_LMB_delivery_MaskGenome.csv", header = T, sep = ",")

Nuclear_virus$Intensity_MeanIntensity_Hex <- as.numeric.factor(Nuclear_virus$Intensity_MeanIntensity_Hex)
Nuclear_virus$Intensity_MeanIntensity_EdC <- as.numeric.factor(Nuclear_virus$Intensity_MeanIntensity_EdC)

Following_patterns <- unique(Nuclear_virus$Metadata_sample, incomparables = FALSE)
print(Following_patterns)

as.numeric.factor <- function(x){
  as.numeric(levels(x))[x]
}

New_genome_counting <- function(exp,strng,thres){
  output2 <- matrix(nrow = 0, ncol = 12)
  exp_size <- unique(exp$Metadata_sample, incomparables = FALSE)
  for (f in seq_along(exp_size)){
    samp <- as.character(exp_size[f])
    Split <- str_split_fixed(samp,"_",n = strng)
    Virus <- Split[,5]
    Drug <- Split[,6]
    sec_spl <- str_split_fixed(samp,"_",n = strng-2)
    good_samp <- sec_spl[,5]
    Time <- as.numeric(Split[,7])
    sample_matrix <- exp[exp$Metadata_sample== samp,]
    sites <- unique(sample_matrix$Metadata_Site, incomparables = FALSE)
    for (sit in seq_along(sites)){
      place <- as.character(sites[sit])
      ce <- subset(sample_matrix, (sample_matrix$Metadata_Site == place))
      ncel <- max(ce$Parent_Cell, na.rm = T)
      if (ncel==-Inf){
        output2 <- output2
      } else {
        for (c in 1:ncel){
          Particles <- length(ce[ce[,"Parent_Cell"] == c,][,1])
          FreeParts <- dim(ce[(ce$Intensity_MeanIntensity_EdC < thres) & (ce$Parent_Cell == c),])[1]
          Nucleus <- length(ce[ce[,"Parent_Nuclus"] == c,][,1])
          FreeNucleus <- dim(ce[(ce$Intensity_MeanIntensity_EdC < thres) & (ce$Parent_Nuclus == c),])[1]
          if (Particles == 0){
            PercentFree <- 0
            PercentFreeNuc <- 0
            PercentFreeCyt <- 0
          } else {
            PercentFree <- (FreeParts/Particles)*100
            PercentFreeNuc <- (FreeNucleus/FreeParts)*100
            PercentFreeCyt <- ((FreeParts-FreeNucleus)/FreeParts)*100
          }
          output2 <- rbind(output2,c(good_samp, Virus, Drug, Time, c, Particles,FreeParts, Nucleus,FreeNucleus,PercentFree, PercentFreeNuc,PercentFreeCyt))
        }
      }
    }
  }
  colnames(output2) <- c("Sample","Virus","Drug","Time","Cell", "Particles", "Free_Particles",
                         "Nuc_Part","Free_Nuc_Part","Percent_Free",
                         "Percent_Free_Nuc", "Percent_Free_cyt")
  output2 <- as.data.frame(output2)
  output2$Time <- as.numeric.factor(output2$Time)
  output2$Cell <- as.numeric.factor(output2$Cell)
  output2$Particles <- as.numeric.factor(output2$Particles)
  output2$Free_Particles <- as.numeric.factor(output2$Free_Particles)
  output2$Nuc_Part <- as.numeric.factor(output2$Nuc_Part)
  output2$Free_Nuc_Part <- as.numeric.factor(output2$Free_Nuc_Part)
  output2$Percent_Free <- as.numeric.factor(output2$Percent_Free)
  output2$Percent_Free_Nuc <- as.numeric.factor(output2$Percent_Free_Nuc)
  output2$Percent_Free_cyt <- as.numeric.factor(output2$Percent_Free_cyt)
  return(output2)
}

Partcount <- New_genome_counting(Nuclear_virus, 7,0.04)

### Subset your viruses and treatments -----------------

wt <- subset(Partcount, (Partcount$Sample == "wt_Mock_30") | 
               (Partcount$Sample == "wt_Mock_180"))

dV <- subset(Partcount, (Partcount$Sample == "dV_Mock_30") | 
               (Partcount$Sample == "dV_Mock_180"))

Combined_virus <- rbind(wt, dV)
Combined_virus$Sample <- factor(Combined_virus$Sample,
                                levels = c("wt_Mock_30","wt_Mock_180",
                                           "dV_Mock_30","dV_Mock_180"))


ggplot(data = Combined_virus, aes(x = Sample, y = Particles,
                                  color=Percent_Free, shape=Virus))+
  geom_point(binaxis='y', stackdir='center', stackratio=5,
             size = 2, alpha=0.8, position = position_jitter(width = 0.17))+
  scale_shape_manual(values=c(17, 19)) +
  scale_color_gradient2(midpoint= 50, low="red", mid="gray83", high="blue") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="errorbar", color="black", width=0.2) +
  stat_summary(fun.y=mean, geom="point",shape= 19, color="black", width=0.2) +
  ylab("      Viral genomes
       devoid of capsid (%)") +
  ylim(0,100) +
  theme(axis.title = element_blank(),
        axis.title.x = element_blank()) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1, colour = 'black'), axis.ticks = element_line(colour = 'black'))+
  theme(axis.text.y = element_text(colour = 'black'))

#####
### Now the genomes
#####

Masked_genome <- read.csv2("191022_dV_VKR_EdC_LMB_delivery_MaskGenome.csv", header = T, sep = ",")

Masked_genome$Intensity_MeanIntensity_Hex <- as.numeric.factor(Masked_genome$Intensity_MeanIntensity_Hex)
Masked_genome$Intensity_MeanIntensity_EdC <- as.numeric.factor(Masked_genome$Intensity_MeanIntensity_EdC)

Following_patterns <- unique(Masked_genome$Metadata_sample, incomparables = FALSE)
print(Following_patterns)

as.numeric.factor <- function(x){
  as.numeric(levels(x))[x]
}

New_genome_counting <- function(exp,strng,thres){
  output2 <- matrix(nrow = 0, ncol = 14)
  exp_size <- unique(exp$Metadata_sample, incomparables = FALSE)
  for (f in seq_along(exp_size)){
    samp <- as.character(exp_size[f])
    Split <- str_split_fixed(samp,"_",n = strng)
    Virus <- Split[,5]
    Drug <- Split[,6]
    sec_spl <- str_split_fixed(samp,"_",n = strng-2)
    good_samp <- sec_spl[,5]
    Time <- as.numeric(Split[,7])
    sample_matrix <- exp[exp$Metadata_sample== samp,]
    sites <- unique(sample_matrix$Metadata_Site, incomparables = FALSE)
    for (sit in seq_along(sites)){
      place <- as.character(sites[sit])
      ce <- subset(sample_matrix, (sample_matrix$Metadata_Site == place))
      ncel <- max(ce$Parent_Cell, na.rm = T)
      if (ncel==-Inf){
        output2 <- output2
      } else {
        for (c in 1:ncel){
          Genomes <- length(ce[ce[,"Parent_Cell"] == c,][,1])
          FreeNomes <- dim(ce[(ce$Intensity_MeanIntensity_Hex < thres) & (ce$Parent_Cell == c),])[1]
          Nucleus <- length(ce[ce[,"Parent_Nuclus"] == c,][,1])
          FreeNucleus <- dim(ce[(ce$Intensity_MeanIntensity_Hex < thres) & (ce$Parent_Nuclus == c),])[1]
          if (Genomes == 0){
            PercentFree <- 0
            PercentFreeNuc_rel <- 0
            PercentFreeNuc_abs <- 0
            PercentFreeCyt_rel <- 0
            PercentFreeCyt_abs <- 0
          } else {
            PercentFree <- (FreeNomes/Genomes)*100
            PercentFreeNuc_rel <- (FreeNucleus/FreeNomes)*100
            PercentFreeNuc_abs <- (FreeNucleus/Genomes)*100
            PercentFreeCyt_rel <- ((FreeNomes-FreeNucleus)/FreeNomes)*100
            PercentFreeCyt_abs <- ((FreeNomes-FreeNucleus)/Genomes)*100
          }
          output2 <- rbind(output2,c(good_samp, Virus, Drug, Time, c, Genomes,FreeNomes, 
                                     Nucleus,FreeNucleus,PercentFree, 
                                     PercentFreeNuc_rel,PercentFreeCyt_rel, 
                                     PercentFreeNuc_abs, PercentFreeCyt_abs))
        }
      }
    }
  }
  colnames(output2) <- c("Sample","Virus","Drug","Time","Cell", "Genomes", "Free_Genomes",
                         "Nuc_Gen","Free_Nuc_Gen","Percent_Free",
                         "Percent_Free_Nuc_rel", "Percent_Free_cyt_rel",
                         "Percent_Free_Nuc_abs", "Percent_Free_cyt_abs")
  output2 <- as.data.frame(output2)
  output2$Time <- as.numeric.factor(output2$Time)
  output2$Cell <- as.numeric.factor(output2$Cell)
  output2$Genomes <- as.numeric.factor(output2$Genomes)
  output2$Free_Genomes <- as.numeric.factor(output2$Free_Genomes)
  output2$Nuc_Gen <- as.numeric.factor(output2$Nuc_Gen)
  output2$Free_Nuc_Gen <- as.numeric.factor(output2$Free_Nuc_Gen)
  output2$Percent_Free <- as.numeric.factor(output2$Percent_Free)
  output2$Percent_Free_Nuc_rel <- as.numeric.factor(output2$Percent_Free_Nuc_rel)
  output2$Percent_Free_cyt_rel <- as.numeric.factor(output2$Percent_Free_cyt_rel)
  output2$Percent_Free_Nuc_abs <- as.numeric.factor(output2$Percent_Free_Nuc_abs)
  output2$Percent_Free_cyt_abs <- as.numeric.factor(output2$Percent_Free_cyt_abs)
  return(output2)
}

Gencount <- New_genome_counting(Masked_genome, 7,0.015)

wt <- subset(Gencount, (Gencount$Sample == "wt_Mock_30") | 
               (Gencount$Sample == "wt_Mock_180") |
               (Gencount$Sample == "wt_LMB_180") |
               (Gencount$Sample == "wt_LMB_300") |
               (Gencount$Sample == "wt_LMB_480"))

wt <- subset(Gencount, (Gencount$Sample == "wt_LMB_180"))
VKR <- subset(Gencount, (Gencount$Sample == "VKR_LMB_180"))
dV <- subset(Gencount, (Gencount$Sample == "dV_LMB_180"))

VKR <- subset(Gencount, (Gencount$Sample == "VKR_Mock_30") | 
               (Gencount$Sample == "VKR_Mock_180") |
                (Gencount$Sample == "VKR_LMB_180") |
                (Gencount$Sample == "VKR_LMB_300") |
                (Gencount$Sample == "VKR_LMB_480") |
               (Gencount$Sample == "dV_LMB_480"))

Combined_LMB <- rbind(wt, VKR)
Combined_LMB$Sample <- factor(Combined_LMB$Sample,
                                  levels = c("wt_Mock_30","wt_Mock_180","wt_LMB_180","wt_LMB_300","wt_LMB_480",
                                             "VKR_Mock_30","VKR_Mock_180","VKR_LMB_180","VKR_LMB_300","VKR_LMB_480", "dV_LMB_480"))

Combined_LMB <- rbind(wt, VKR, dV)
Combined_LMB$Sample <- factor(Combined_LMB$Sample,
                              levels = c("wt_LMB_180", "VKR_LMB_180","dV_LMB_180"))


ggplot(data = Combined_LMB, aes(x = Sample, y = Percent_Free,
                                  color=Percent_Free_Nuc_rel, shape=Virus))+
  geom_point(aes (size =Combined_LMB$Virus), binaxis='y', stackdir='center', stackratio=5,
             alpha=0.8, position = position_jitter(width = 0.17))+
  scale_shape_manual(values=c("\u25B2", "\u25BC", "\u25CF")) +
  scale_size_manual(values=c(3,2.7,4)) +
  scale_color_gradient2(midpoint= 50, low="red", mid="gray83", high="blue") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="errorbar", color="black", width=0.2) +
  stat_summary(fun.y=mean, geom="point",shape= 19, color="black", width=0.2) +
  ylab("      Viral genomes
       devoid of capsid (%)") +
  ylim(0,100) +
  theme(axis.title = element_blank(),
        axis.title.x = element_blank()) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1, colour = 'black'), axis.ticks = element_line(colour = 'black'))+
  theme(axis.text.y = element_text(colour = 'black'))
